#ifndef ADV_HPP
#  define ADV_HPP

#  include <boost/units/systems/si.hpp>
using namespace boost::units;

#  include <blitz/array.h>
using namespace blitz;

template <class unit, typename real_t>
class adv
{
  public: virtual const int stencil_extent() = 0;
  public: virtual const int time_levels() = 0;
  public: virtual const int num_steps() = 0;
  public: virtual void op(Array<quantity<unit, real_t>, 1> *psi[], const Range &i, 
    const int n, const quantity<si::dimensionless, real_t> &C, int step) = 0;
};
#endif
